Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Project Rio
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.jini.rio.jsb
Class ServiceBeanAdapter

    java.lang.Object
      org.jini.rio.resources.servicecore.ServiceProvider
          org.jini.rio.jsb.ServiceBeanAdapter

All Implemented Interfaces:
  ServiceProxyAccessor, Remote, MBeanRegistration, NotificationBroadcaster, NotificationEmitter, Administrable, ProxyAccessor, ServerProxyTrust, ServiceBean, MonitorableService, EventProducer, ServiceBeanAdapterMBean, Service, Watchable

Direct Known Subclasses:
  BeanAdapter, JMXConnectorService

    public abstract class ServiceBeanAdapter

extends ServiceProvider
implements ServiceBean, ServiceProxyAccessor, ServerProxyTrust, ProxyAccessor, ServiceBeanAdapterMBean, MBeanRegistration, NotificationEmitter

The ServiceBeanAdapter implements the ServiceBean interface and provides the necessary service infrastructure to make a service developer succesful. Extend this class to take advantage of the Rio ServiceBean capabilities

Nested Class Summary
`class` | `ServiceBeanAdapter.SnapshotThread` A Thread that will perform snapshots.

Field Summary
`protected ActivationID` | `activationID` The activation id for this service.
`protected ServiceAdminImpl` | `admin` The ServiceAdmin implementation for this ServiceBeanAdapter
`protected ComputeResource` | `computeResource` A reference to the compute resource for this ServiceBean
`protected ComputeResourceObserver` | `computeResourceObserver` Observe the ComputeResource object associated with this ServiceBean.
`protected ServiceBeanContext` | `context` A ServiceBeanContext provides the ServiceBean with necessary context required to obtain information about it's environment, attributes and ServiceBeanManager instance
`protected ServiceBeanContextManager` | `contextMgr` Manages persistence of the ServiceBeanContext
`protected Joiner` | `joiner` Joiner utility that contains a JoinManager and provides general utility to set the ServiceProvider's attribute collection
`protected ServiceBeanState` | `jsbState` The ServiceBeanState component, managing the state of the ServiceBean
`protected String` | `logDirName` The location on the filesystem for persistence
`protected List<MBeanNotificationInfo>` | `mbeanNoticationInfoList`
`protected MBeanServer` | `mbeanServer`
`protected ObjectName` | `objectName`
`protected Object` | `proxy` The proxy object for the service that will be registered into the lookup service
`protected String` | `serviceBeanComponent` Component name we use to find items in the configuration.
`protected ServiceID` | `serviceID` The serviceID for the ServiceBean
`protected SLAThresholdEventAdapter` | `slaThresholdEventAdapter`
`protected ServiceBeanAdapter.SnapshotThread` | `snapshotter` Thread that will do snapshots
`protected int` | `state` The state of the ServiceBean
`protected PersistentStore` | `store` PersistentStore the ServiceBeanContextManager uses to manage the state of the ServiceBeanContext
`protected Uuid` | `uuid` The Uuid for the ServiceBean

Fields inherited from class org.jini.rio.resources.servicecore.ServiceProvider
`eventTable, watchRegistry`

Constructor Summary
`ServiceBeanAdapter()` Construct a ServiceBeanAdapter

Method Summary
`void` | `addAttribute(Entry attribute)` Add an attribute to the Collection of attributes the Joiner utility maintains.
`void` | `addAttributes(Entry[] attributes)` Add attributes to the Collection of attributes the Joiner utility maintains.
`void` | `addNotificationListener(NotificationListener listener, NotificationFilter filter, Object object)`
`void` | `advertise()` The advertise method provides the capability for a ServiceBean to advertise itself on the network providing access to all clients.
`protected void` | `cleanJMX()` Called from destroy() (or if the service bean is aborted during start) to cleanup JMX resources and unregister from MBeanServer
`protected ObjectName` | `createObjectName(ServiceBeanContext context)` Create JMX ObjectName used for MBeanServer registration
`protected Object` | `createProxy()` Create the Object (the proxy) to communicate with the ServiceBean.
`void` | `destroy()` Left for concrete implementations of this class to implement
`void` | `destroy(boolean force)` The destroy method is used to destroy an instance of a ServiceBean.
`protected void` | `destroyWatches()` Close down all WatchDataSource instances, unexporting them from the runtime
`protected Remote` | `exportDo(Exporter exporter)` This method exports the remote object making it available to receive incoming calls
`Object` | `getAdmin()` Provide a concrete implementation of getAdmin
`protected Exporter` | `getAdminExporter()` Get the Exporter to export the ServiceAdmin
`AssociationManagement` | `getAssociationManagement()` Deprecated. Use ServiceBeanContext.getAssociationManagement() instead
`Association[]` | `getAssociations()` Deprecated. Use ServiceBeanContext.getAssociationManagement() instead
`protected ComputeResourceObserver` | `getComputeResourceObserver()` Get the ComputeResourceObserver
`DiscoveryManagement` | `getDiscoveryManager()` Deprecated. Use ServiceBeanContext.getDiscoveryManager
`protected Remote` | `getExportedProxy()` Get the Object created by the configured Exporter
`protected Exporter` | `getExporter(Configuration config)` Get the configured Exporter
`JoinManager` | `getJoinManager()` Get the JoinManager created by the Joiner utility
`String[]` | `getLookupGroups()` Get the discovery groups
`NotificationBroadcasterSupport` | `getNotificationBroadcasterSupport()`
`MBeanNotificationInfo[]` | `getNotificationInfo()`
`Object` | `getProxy()`
`TrustVerifier` | `getProxyVerifier()` Returns a `TrustVerifier` which can be used to verify that a given proxy to this service can be trusted
`ServiceBeanContext` | `getServiceBeanContext()` Get the ServiceBeanContext
`Uuid` | `getServiceBeanInstantiatorUuid()` Get the Uuid of the Cybernode
`Object` | `getServiceProxy()` Get the Object (the proxy) to communicate with the ServiceBean.
`EventHandler` | `getSLAEventHandler()` Get the EventHandler that has been created to handle the sending of SLAThresholdEvent event objects to registered EventConsumer clients
`Date` | `getStarted()` Get the Date the ServiceBean was started
`long` | `getStartTime()`
`Uuid` | `getUuid()` Get the Uuid
`protected Entry` | `getWatchUI()` Get the Watch Ui (User Interface) UIDescriptor.
`void` | `initialize(ServiceBeanContext context)` The initialize method is invoked to initialize the ServiceBean.
`void` | `initialize(ServiceBeanContext context, PersistentStore store)` The initialize method is invoked to initialize the ServiceBean.
`protected void` | `initializeJMX(ServiceBeanContext context)` Called from initialize() to prepare JMX resources such as registering with MBeanServer
`Lease` | `monitor(long duration)` Establish a Lease to monitor the reachability of the Service
`void` | `ping()` Low cost roundtrip check
`void` | `postDeregister()` Called after unregistering from MBeanServer.
`void` | `postRegister(Boolean aBoolean)` Implemented as part of the contract for a `MBeanRegistration`, empty implementation
`void` | `preDeregister()` Implemented as part of the contract for a `MBeanRegistration`, empty implementation
`ObjectName` | `preRegister(MBeanServer mBeanServer, ObjectName objectName)` Save registered objectName and MBeanServer as members
`protected void` | `registerMBean(ObjectName oName, MBeanServer mbeanServer)` Register the service using the ObjectName to the MBeanServer
`void` | `removeNotificationListener(NotificationListener listener)`
`void` | `removeNotificationListener(NotificationListener listener, NotificationFilter filter, Object object)`
`void` | `setLookupGroups(String[] groups)` Set the discovery groups
`Object` | `start(ServiceBeanContext context)` The start method provides the capability for a ServiceBean to initialize itself and make it ready to accept inbound communications, returning an Object which can be used to communicate with the ServiceBean.
`void` | `startHeartbeat(String[] configArgs)` Start a heartbeat mechanism to determine the reachability of the Service.
`void` | `stop(boolean force)` The stop method informs the ServiceBean to unexport itself from any underlying distributed Object communication mechanisms making it incapable of accepting inbound communications
`void` | `unadvertise()` The unadvertise method informs the ServiceBean to cancel all advertisements (registrations, etc...) it has made on the network.

Methods inherited from class org.jini.rio.resources.servicecore.ServiceProvider
`fetch, fetch, getConfiguration, getEventTable, getWatchRegistry, register, setConfiguration, setEventTable, setWatchRegistry`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### context

    protected ServiceBeanContext context

  A ServiceBeanContext provides the ServiceBean with necessary context required to obtain information about it's environment, attributes and ServiceBeanManager instance

### uuid

    protected Uuid uuid

  The Uuid for the ServiceBean

### serviceID

    protected ServiceID serviceID

  The serviceID for the ServiceBean

### admin

    protected ServiceAdminImpl admin

  The ServiceAdmin implementation for this ServiceBeanAdapter

### joiner

    protected Joiner joiner

  Joiner utility that contains a JoinManager and provides general utility to set the ServiceProvider's attribute collection

### proxy

    protected Object proxy

  The proxy object for the service that will be registered into the lookup service

### computeResource

    protected ComputeResource computeResource

  A reference to the compute resource for this ServiceBean

### computeResourceObserver

    protected ComputeResourceObserver computeResourceObserver

  Observe the ComputeResource object associated with this ServiceBean. As this object changes the ComputeResourceUtilizationEntry will be changed to reflect a change in the quantitative and/or qualitative mechanisms reflected by the ComputeResource object

### logDirName

    protected String logDirName

  The location on the filesystem for persistence

### snapshotter

    protected ServiceBeanAdapter.SnapshotThread snapshotter

  Thread that will do snapshots

### contextMgr

    protected ServiceBeanContextManager contextMgr

  Manages persistence of the ServiceBeanContext

### store

    protected PersistentStore store

  PersistentStore the ServiceBeanContextManager uses to manage the state of the ServiceBeanContext

### state

    protected int state

  The state of the ServiceBean

### jsbState

    protected ServiceBeanState jsbState

  The ServiceBeanState component, managing the state of the ServiceBean

### activationID

    protected ActivationID activationID

  The activation id for this service. This attribute will be valid if and only if the object has been registered with the activation system, and the Service that extends this class sets the ActivationID provided by the activation system as part of its constructor.

### serviceBeanComponent

    protected String serviceBeanComponent

  Component name we use to find items in the configuration. The value is set to the package name of the concrete implementation of this class. If the class has no package name, the component is the name of the class

### objectName

    protected ObjectName objectName

### mbeanServer

    protected MBeanServer mbeanServer

### mbeanNoticationInfoList

    protected final List<MBeanNotificationInfo> mbeanNoticationInfoList

### slaThresholdEventAdapter

    protected SLAThresholdEventAdapter slaThresholdEventAdapter

Constructor Detail

### ServiceBeanAdapter

    public ServiceBeanAdapter()

  Construct a ServiceBeanAdapter

Method Detail

### start

    public Object start(ServiceBeanContext context)
                 throws Exception

  The start method provides the capability for a ServiceBean to initialize itself and make it ready to accept inbound communications, returning an Object which can be used to communicate with the ServiceBean. It is the responsibility of the ServiceBean to initiate appropriate startup logic. If the ServiceBean has started itself, subsequent invocations of this method will not re-start the ServiceBean, but return the Object created during the initial start

  Specified by:
    `start` in interface `ServiceBean`
  Parameters:
    `context` - The ServiceBeanContext containing ServiceBean initialization attributes
  Returns:
    An Object that can be used to communicate to the ServiceBean
  Throws:
    `Exception` - If any errors or unexpected conditions occur

### initialize

    public void initialize(ServiceBeanContext context)
                    throws Exception

  The initialize method is invoked to initialize the ServiceBean. This method is invoked only once. The ServiceBeanAdapter initializes required infrastructure elements in order to prepare the ServiceBean for processing.

  Specified by:
    `initialize` in interface `ServiceBean`
  Parameters:
    `context` - The ServiceBeanContext to intialize the ServiceBean with
  Throws:
    `Exception` - If something unexpected happens

### initialize

    public void initialize(ServiceBeanContext context,
                           PersistentStore store)
                    throws Exception

  The initialize method is invoked to initialize the ServiceBean. This method is invoked only once. The ServiceBeanAdapter initializes required infrastructure elements in order to prepare the ServiceBean for processing.

  Parameters:
    `context` - The ServiceBeanContext to intialize the ServiceBean. If this parameter is null a NullPointerException is thrown
    `store` - A PersistentStore which will be used as a basis to create a ServiceBeanContextManager used to manage the state of the ServiceBeanContext. If this parameter is null, a ServiceBeanContextManager will not be created
  Throws:
    `Exception` - If something unexpected happens

### getComputeResourceObserver

    protected ComputeResourceObserver getComputeResourceObserver()

  Get the ComputeResourceObserver

  Returns:
    ComputeResourceObserver The ComputeResourceObserver for the service bean

### initializeJMX

    protected void initializeJMX(ServiceBeanContext context)
                          throws Exception

  Called from initialize() to prepare JMX resources such as registering with MBeanServer

  Parameters:
    `context` - The ServiceBeanContext
  Throws:
    `Exception` - If errors occur

### registerMBean

    protected void registerMBean(ObjectName oName,
                                 MBeanServer mbeanServer)
                          throws NotCompliantMBeanException,
                                 MBeanRegistrationException,
                                 InstanceAlreadyExistsException

  Register the service using the ObjectName to the MBeanServer

  Parameters:
    `oName` - The ObjectNae to register
    `mbeanServer` - The MBeanServer to use
  Throws:
    `NotCompliantMBeanException` - If the bean is not compliant
    `MBeanRegistrationException` - If the bean is already registered
    `InstanceAlreadyExistsException` - If the instance already exists

### cleanJMX

    protected void cleanJMX()

  Called from destroy() (or if the service bean is aborted during start) to cleanup JMX resources and unregister from MBeanServer

### createObjectName

    protected ObjectName createObjectName(ServiceBeanContext context)
                                   throws MalformedObjectNameException

  Create JMX ObjectName used for MBeanServer registration

  Parameters:
    `context` - The ServiceBeanContext to use
  Returns:
    ObjectName used for registeration
  Throws:
    `MalformedObjectNameException` - If there are erros creating the JMX object name

### preRegister

    public ObjectName preRegister(MBeanServer mBeanServer,
                                  ObjectName objectName)
                           throws Exception

  Save registered objectName and MBeanServer as members

  Specified by:
    `preRegister` in interface `MBeanRegistration`
  Throws:
    `Exception`
  See Also:
    `MBeanRegistration.preRegister(javax.management.MBeanServer, javax.management.ObjectName)`

### postRegister

    public void postRegister(Boolean aBoolean)

  Implemented as part of the contract for a `MBeanRegistration`, empty implementation

  Specified by:
    `postRegister` in interface `MBeanRegistration`

### preDeregister

    public void preDeregister()
                       throws Exception

  Implemented as part of the contract for a `MBeanRegistration`, empty implementation

  Specified by:
    `preDeregister` in interface `MBeanRegistration`
  Throws:
    `Exception`

### postDeregister

    public void postDeregister()

  Called after unregistering from MBeanServer. Unreference JMX resources.

  Specified by:
    `postDeregister` in interface `MBeanRegistration`
  See Also:
    `MBeanRegistration.postDeregister()`

### getServiceBeanContext

    public ServiceBeanContext getServiceBeanContext()

  Get the ServiceBeanContext

  Returns:
    The ServiceBeanContext for the ServiceBean

### getAssociationManagement

    public AssociationManagement getAssociationManagement()

  Deprecated. Use ServiceBeanContext.getAssociationManagement() instead

  Get the AssociationManagement object

  Returns:
    The AssociationManagement object

### getAssociations

    public Association[] getAssociations()

  Deprecated. Use ServiceBeanContext.getAssociationManagement() instead

  Get all Association instances

  Returns:
    Array of Association instances

### getWatchUI

    protected Entry getWatchUI()
                        throws IOException

  Get the Watch Ui (User Interface) UIDescriptor. This method will use watch-ui.jar as the JAR which contains the org.jini.rio.watch.AccumulatorViewer class. If the org.jini.rio.watch.AccumulatorViewer class is in a different JAR or the Watch UI is a different class, this method should overriden

  Returns:
    The Entry object describing the AccumulatorViewer UIDescriptor
  Throws:
    `IOException` - If erros occur creating the Entry

### getExportedProxy

    protected Remote getExportedProxy()

  Get the Object created by the configured Exporter

  Returns:
    The Object used to communicate to this service

### createProxy

    protected Object createProxy()

  Create the Object (the proxy) to communicate with the ServiceBean. This method is called by the getServiceProxy() method if the proxy is `null` or the ServiceBean has not been started. The default semantic is to return the Remote Object created by the exporter. If a different Object (proxy) is required, concrete implementations of the ServiceBeanAdapter must override this method and set the desired Object

  Returns:
    The proxy to use

### getServiceProxy

    public Object getServiceProxy()

  Get the Object (the proxy) to communicate with the ServiceBean. If the proxy is `null`, the `createProxy` method will be called to return the proxy to communicate to the ServiceBean. The proxy attribute will only be created iff the proxy attribute is null.

  Specified by:
    `getServiceProxy` in interface `ServiceProxyAccessor`
  Specified by:
    `getServiceProxy` in class `ServiceProvider`
  Returns:
    The Object used to communicate to this service

### getProxy

    public Object getProxy()

  Specified by:
    `getProxy` in interface `ProxyAccessor`
  See Also:
    `ProxyAccessor.getProxy()`

### getProxyVerifier

    public TrustVerifier getProxyVerifier()

  Returns a `TrustVerifier` which can be used to verify that a given proxy to this service can be trusted

  Specified by:
    `getProxyVerifier` in interface `ServerProxyTrust`

### getDiscoveryManager

    public DiscoveryManagement getDiscoveryManager()
                                            throws IOException

  Deprecated. Use ServiceBeanContext.getDiscoveryManager

  Get the DiscoveryManagement instance for this service. If the DiscoveryManagement attribute is null, this method will create a DiscoveryManager instance. If the DiscoveryManagement attribute is not null, this method will return the DiscoveryManagement instance that has already been created

  Returns:
    A DiscoveryManagement instance created from the ServiceBeanContext
  Throws:
    `IOException` - because construction of the class DiscoveryManagament implementation may initiate the discovery process, which can throw an IOException when socket allocation occurs.

### getSLAEventHandler

    public EventHandler getSLAEventHandler()

  Get the EventHandler that has been created to handle the sending of SLAThresholdEvent event objects to registered EventConsumer clients

  Returns:
    The EventHandler that has been created to handle the sending of SLAThresholdEvent events

### addAttribute

    public void addAttribute(Entry attribute)

  Add an attribute to the Collection of attributes the Joiner utility maintains. If the ServiceBean is advertised, the new attribute will be added to the collection of attributes for the ServiceBean

  Parameters:
    `attribute` - Entry to add

### addAttributes

    public void addAttributes(Entry[] attributes)

  Add attributes to the Collection of attributes the Joiner utility maintains. If the ServiceBean is advertised, the new attributes will be added to the collection of attributes for the ServiceBean

  Parameters:
    `attributes` - Array of Entry attributes

### advertise

    public void advertise()
                   throws IOException

  Description copied from interface: `ServiceBean`
  The advertise method provides the capability for a ServiceBean to advertise itself on the network providing access to all clients. The ServiceBean must be ready to accept incoming communications (has been started). If the ServiceBean has advertised itself, subsequent invocations of this method will not re-advertise the ServiceBean

  Specified by:
    `advertise` in interface `ServiceBean`
  Specified by:
    `advertise` in interface `ServiceBeanAdapterMBean`
  Throws:
    `IOException` - If errors occur access underlying communication mechanisms
  See Also:
    `ServiceBeanAdapterMBean.advertise()`

### unadvertise

    public void unadvertise()

  Description copied from interface: `ServiceBean`
  The unadvertise method informs the ServiceBean to cancel all advertisements (registrations, etc...) it has made on the network. The ServiceBean must still be available to accept incoming communications. If the ServiceBean has not advertised itself, this method has no defined behavior

  Specified by:
    `unadvertise` in interface `ServiceBean`
  Specified by:
    `unadvertise` in interface `ServiceBeanAdapterMBean`
  See Also:
    `ServiceBeanAdapterMBean.unadvertise()`

### stop

    public void stop(boolean force)

  The stop method informs the ServiceBean to unexport itself from any underlying distributed Object communication mechanisms making it incapable of accepting inbound communications

  Specified by:
    `stop` in interface `ServiceBean`
  Parameters:
    `force` - If true, unexports the ServiceBean even if there are pending or in-progress calls; if false, only unexports the ServiceBean if there are no pending or in-progress calls. If the `force` parameters is `false`, unexporting the ServiceBean will be governed by the following configuration properties:
    - `maxUnexportDelay` Indicates the maximum amount of time to wait for unexport attempts
    - `unexportRetryDelay` Length of time to sleep between unexport attempts
  Throws:
    `IllegalStateException` - If the state transition is illegal

### getAdmin

    public Object getAdmin()

  Provide a concrete implementation of getAdmin

  Specified by:
    `getAdmin` in interface `Administrable`
  Specified by:
    `getAdmin` in class `ServiceProvider`
  Returns:
    A ServiceAdminProxy instance to administer the ServiceBean

### destroyWatches

    protected void destroyWatches()

  Close down all WatchDataSource instances, unexporting them from the runtime

### destroy

    public void destroy()

  Description copied from class: `ServiceProvider`
  Left for concrete implementations of this class to implement

  Specified by:
    `destroy` in interface `ServiceBeanAdapterMBean`
  Specified by:
    `destroy` in class `ServiceProvider`
  See Also:
    `ServiceBeanAdapterMBean.destroy()`

### destroy

    public void destroy(boolean force)

  Description copied from interface: `ServiceBean`
  The destroy method is used to destroy an instance of a ServiceBean. Once this method is invoked the ServiceBean should provide appropriate termination logic including unadvertise() and stop() method invocations. Note: The implementer of this method should not invoke System.exit() during the processing of this method

  Specified by:
    `destroy` in interface `ServiceBean`
  Specified by:
    `destroy` in interface `ServiceBeanAdapterMBean`
  Parameters:
    `force` - If true, unexports the ServiceBean even if there are pending or in-progress calls; if false, only unexports the ServiceBean if there are no pending or in-progress calls
  See Also:
    `ServiceBeanAdapterMBean.destroy(boolean)`

### monitor

    public Lease monitor(long duration)
                  throws LeaseDeniedException,
                         RemoteException

  Description copied from interface: `MonitorableService`
  Establish a Lease to monitor the reachability of the Service

  Specified by:
    `monitor` in interface `MonitorableService`
  Parameters:
    `duration` - The duration (in milliseconds) of the requested Lease
  Returns:
    Lease The Lease to maintain
  Throws:
    `LeaseDeniedException` - If requested Lease is denied
    `RemoteException` - If communication errors occur
  See Also:
    `MonitorableService.monitor(long)`

### startHeartbeat

    public void startHeartbeat(String[] configArgs)
                        throws ConfigurationException,
                               RemoteException

  Description copied from interface: `MonitorableService`
  Start a heartbeat mechanism to determine the reachability of the Service. The endpoint to send the heartbeat to will be found by the configuration property

       org.jini.rio.FaultDetectionHandler.heartbeatServer

  Specified by:
    `startHeartbeat` in interface `MonitorableService`
  Parameters:
    `configArgs` - Configuration attributes the Service will use to establish a heartbeat mechanism
  Throws:
    `ConfigurationException` - If there are errors processing the configuration
    `RemoteException` - If communication errors occur
  See Also:
    `MonitorableService.startHeartbeat(java.lang.String[])`

### ping

    public void ping()
              throws RemoteException

  Description copied from interface: `MonitorableService`
  Low cost roundtrip check

  Specified by:
    `ping` in interface `MonitorableService`
  Throws:
    `RemoteException` - If an error occured during communication with the service
  See Also:
    `MonitorableService.ping()`

### getUuid

    public Uuid getUuid()

  Get the Uuid

  Specified by:
    `getUuid` in class `ServiceProvider`
  Returns:
    The Uuid

### getServiceBeanInstantiatorUuid

    public Uuid getServiceBeanInstantiatorUuid()

  Get the Uuid of the Cybernode

  Returns:
    The Uuid of the Cybernode

### getJoinManager

    public JoinManager getJoinManager()

  Get the JoinManager created by the Joiner utility

  Returns:
    The JoinManager created by the Joiner. May be null

### getExporter

    protected Exporter getExporter(Configuration config)
                            throws Exception

  Get the configured Exporter

  Parameters:
    `config` - The configuration to obtain
  Returns:
    An Exporter which can be used to export the service. If no Exporter has been configured, a new BasicJeriExporter with
    - A TcpServerEndpoint created on a random port,
    - a BasicILFactory,
    - distributed garbage collection turned off,
    - keep alive on.
    If activatable, the same default will be used but wrapped in an ActivationExporter and created with the service's ActivationID
  Throws:
    `Exception` - If there are errors getting the Exporter

### exportDo

    protected Remote exportDo(Exporter exporter)
                       throws Exception

  This method exports the remote object making it available to receive incoming calls

  Parameters:
    `exporter` - The Exporter to use, must not be null
  Returns:
    Remote The remote object used to accept incoming calls
  Throws:
    `Exception` - If errors occur

### getStarted

    public Date getStarted()

  Description copied from interface: `ServiceBeanAdapterMBean`
  Get the Date the ServiceBean was started

  Specified by:
    `getStarted` in interface `ServiceBeanAdapterMBean`
  See Also:
    `ServiceBeanAdapterMBean.getStarted()`

### getStartTime

    public long getStartTime()

### getLookupGroups

    public String[] getLookupGroups()

  Description copied from interface: `ServiceBeanAdapterMBean`
  Get the discovery groups

  Specified by:
    `getLookupGroups` in interface `ServiceBeanAdapterMBean`
  See Also:
    `ServiceBeanAdapterMBean.getLookupGroups()`

### setLookupGroups

    public void setLookupGroups(String[] groups)

  Description copied from interface: `ServiceBeanAdapterMBean`
  Set the discovery groups

  Specified by:
    `setLookupGroups` in interface `ServiceBeanAdapterMBean`
  See Also:
    `ServiceBeanAdapterMBean.setLookupGroups(java.lang.String[])`

### getAdminExporter

    protected Exporter getAdminExporter()
                                 throws ConfigurationException,
                                        UnknownHostException

  Get the Exporter to export the ServiceAdmin

  Returns:
    The Exporter obtained from the Configuration matching the package name of the concrete implementation of this class with the name adminExporter
  Throws:
    `ConfigurationException` - If there are errors reading the configuration
    `UnknownHostException` - If the host is unknown

### removeNotificationListener

    public void removeNotificationListener(NotificationListener listener,
                                           NotificationFilter filter,
                                           Object object)
                                    throws ListenerNotFoundException

  Specified by:
    `removeNotificationListener` in interface `NotificationEmitter`
  Throws:
    `ListenerNotFoundException`

### addNotificationListener

    public void addNotificationListener(NotificationListener listener,
                                        NotificationFilter filter,
                                        Object object)
                                 throws IllegalArgumentException

  Specified by:
    `addNotificationListener` in interface `NotificationBroadcaster`
  Throws:
    `IllegalArgumentException`

### removeNotificationListener

    public void removeNotificationListener(NotificationListener listener)
                                    throws ListenerNotFoundException

  Specified by:
    `removeNotificationListener` in interface `NotificationBroadcaster`
  Throws:
    `ListenerNotFoundException`

### getNotificationInfo

    public MBeanNotificationInfo[] getNotificationInfo()

  Specified by:
    `getNotificationInfo` in interface `NotificationBroadcaster`

### getNotificationBroadcasterSupport

    public NotificationBroadcasterSupport getNotificationBroadcasterSupport()

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Project Rio
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © Project Rio.